unit uSusiePluginDLL;

interface

uses
  SysUtils,Classes,Windows,graphics,uSusiePluginDLL_Core;

{$E .spi}

const
  SpiNotImplement	= -1;	// ̋@\̓CvgĂȂ
  SpiAllRight		= 0;	// I
  SpiAbort		= 1;	// R[obN֐0Ԃ̂œWJ𒆎~
  SpiUnknownFormat	= 2;	// m̃tH[}bg
  SpiOutOfOrder		= 3;	// f[^Ă
  SpiNoMemory		= 4;	// [mۏoȂ
  SpiMemoryError	= 5;	// [G[iLockoȂAj
  SpiFileReadError	= 6;	// t@C[hG[
  SpiReservedError	= 7;	// \
  SpiWindowError	= 7;	// JȂ (JG[R[h)
  SpiInternalError	= 8;	// G[
  SpiFileWriteError	= 9;	// ݃G[ (JG[R[h)
  SpiEndOfFile		= 10;	// t@CI[ (JG[R[h)

  // Plug-in APIo[W
  PlugInfo0 = '00IN';
  // Plug-inAo[Wy copyright
  PlugInfo1 = _PluginName;
  // \IȊgq
  PlugInfo2 = _PluginExt;
  // t@C`
  PlugInfo3 = _PluginFileFormatName;

type
  PByte = ^Byte;
  // PictureInfo
  TPictureInfo = packed record
    Left,Top:Longint;
    Width,Height:Longint;
    x_Density,y_Density:Word;
    colorDepth:	Smallint;
    hInfo:HLOCAL;
  end;
  PPictureInfo = ^TPictureInfo;
  // ProgressCallback
  TProgressCallback = function(nNum, nDenom: Integer; lData: Longint): Integer; stdcall;
  //֐|C^
  function IsSupportedEX(FileName: PChar; Data: PByte):Boolean;
  function GetPictureInfoEx(var PictureInfo: TPictureInfo; Data: PByte): Integer;
  function GetPictureEx(Data: PByte; var HBInfo: HLOCAL; var HBm: HLOCAL;ProgressCallback: TProgressCallback; lData: Longint;DataSize: Longint): Integer;
  //Export֐
  function GetPluginInfo(InfoNo: Integer; Buf: PChar; BufLen: Integer): Integer; stdcall;
  function IsSupported(FileName: PChar; DW: DWORD): Integer; stdcall;
  function GetPictureInfo(Buf: PChar; Len: Longint; Flag: Integer; var PictureInfo: TPictureInfo): Integer; stdcall;
  function GetPicture(Buf: PChar; Len: Longint; Flag: Integer;var HBInfo: HLOCAL; var HBm: HLOCAL;ProgressCallback: TProgressCallback; lData: Longint): Integer; stdcall;
  function GetPreview(Buf: PChar; Len: Longint; Flag: Integer;var HBInfo: HLOCAL; var HBm: HLOCAL;ProgressCallback: TProgressCallback; lData: Longint): Integer; stdcall;
  function ConfigurationDlg(Parent: HWND; fnc: Integer): Integer; stdcall;

//DLL-Export
exports
  ConfigurationDlg,
  GetPluginInfo,
  IsSupported,
  GetPictureInfo,
  GetPicture,
  GetPreview;

//[U[`֐

implementation

// wb_đΉtH[}bgmF.
// ΉĂ̂Ȃ True, łȂ False Ԃ.
// FileName ̓t@C. ͂̎Ȃ nil ̏ꍇ.
// Data ̓t@C̐擪HoCgǂ݂񂾃obt@ւ̃|C^.
function IsSupportedEX(FileName: PChar; Data: PByte):Boolean;
var
  f : String;
  p : pchar;
begin
  f := FileName;
  p := pchar(Data);
  RESULT := _FileCheck(f,p);
end;

// 摜t@C̏,G[R[hԂ.
// Data ̓t@C̐擪HoCgǂ݂񂾃obt@ւ̃|C^.
function GetPictureInfoEx(var PictureInfo: TPictureInfo; Data: PByte): Integer;
var
  p : TPoint;
begin
  RESULT := SpiNotImplement;
  {
  Result := SpiAllRight;
  p := _GetImageSize(Data);

  with PictureInfo do
  begin
    left       := 0;
    top        := 0;
    width      := p.X;
    height     := p.Y;
    x_density  := 0;
    y_density  := 0;
    colorDepth := 32;
    hInfo      := HLOCAL(nil);
  end;    }
end;

// 摜t@CDIBɕϊ,G[R[hԂ.
// Data ̓t@CC[W,TCY DataSize oCg.
function GetPictureEx(Data: PByte; var HBInfo: HLOCAL; var HBm: HLOCAL;ProgressCallback: TProgressCallback; lData: Longint;DataSize: Longint): Integer;
  procedure _FillAlpha(var bmp:TBitmap);
  var
    w,h : Integer;
    i,j : Integer;
    dptr : PDWORD;
  begin
    w := bmp.Width;
    h := bmp.Height;

    for i:=0 to h-1 do
    begin
      dptr := bmp.ScanLine[i];
      for j:=0 to w-1 do
      begin
        dptr^ := dptr^ or $FF000000;
        inc(dptr);
      end;
    end;
  end;
var
  bmp : TBitmap;
  InfoSize : DWORD;
  a,r,g,b : Integer;
  ImgSize : DWORD;
  LineSize: DWORD;
  pInfo : ^BITMAPINFO;
  pBm : PByte;
  i,j : Integer;
  pSrc :PBYTE;
  pDest :PBYTE;
  ww,hh : Integer;
begin
  Result := SpiUnknownFormat;

  //0%
  if (@ProgressCallback <> nil) then
  begin
    if (ProgressCallback(0, 1, lData) <> 0)then
    begin
      Result := SpiAbort;
      Exit;
    end;
  end;

  //Load
  bmp := _GetImage(Data,DataSize);
  if (bmp=nil)then
  begin
    exit;
  end;

  //PixelFormat
  if (bmp.PixelFormat<>pf32Bit)then
  begin
    bmp.PixelFormat := pf32Bit;
    _FillAlpha(bmp);
  end;

  //BitmapHed
  LineSize := (bmp.Width * (24 div 8) +3) and (not 3); //4byteE
  ImgSize := LineSize * bmp.Height;
  InfoSize := sizeof(BITMAPINFOHEADER);

  HBInfo := LocalAlloc(LMEM_MOVEABLE, InfoSize);
  HBm    := LocalAlloc(LMEM_MOVEABLE, Imgsize);

  if ((HBInfo = HLOCAL(nil)) or (HBm = HLOCAL(nil))) then
  begin
    if (HBInfo <> HLOCAL(nil)) then LocalFree(HBInfo);
    if (HBm <> HLOCAL(nil)) then LocalFree(HBm);
    Result := SpiNoMemory;
    Exit;
  end;

  pInfo := LocalLock(HBInfo);
  pBm   := LocalLock(HBm);
  if ((pInfo = nil) or (pBm = nil)) then
  begin
    LocalFree(HBInfo);
    LocalFree(HBm);
    Result := SpiMemoryError;
    Exit;
  end;

  //HBInfoɂBITMAPINFO
  with pInfo.bmiHeader do
  begin
    biSize := sizeof(BITMAPINFOHEADER);
    biWidth := bmp.Width;
    biHeight := bmp.Height;
    biPlanes := 1;
    biBitCount := 24;
    biCompression := BI_RGB;
    biSizeImage := ImgSize;
    biXPelsPerMeter := 0;
    biYPelsPerMeter := 0;
    biClrUsed := 0;
    biClrImportant := 0;
  end;

  //HBmɂ̓rbg}bvf[^
  hh := bmp.Height;
  ww := bmp.Width;
  for i:=0 to hh-1 do
  begin
    pDest:= Pointer(DWORD(pBm)+LineSize*i);
    pSrc := bmp.ScanLine[hh-1-i];
    for j:=0 to ww-1 do
    begin
      b := pSrc^;  Inc(pSrc);
      g := pSrc^;  Inc(pSrc);
      r := pSrc^;  Inc(pSrc);
      a := pSrc^;  Inc(pSrc);
      pDest^ := b; Inc(pDest);
      pDest^ := g; Inc(pDest);
      pDest^ := r; Inc(pDest);
    end;
  end;
  
  bmp.Free;
  
  LocalUnlock(HBInfo);
  LocalUnlock(HBm);

  RESULT := SpiAllRight;
end;

// Plug-inɊւ𓾂
function GetPluginInfo(InfoNo: Integer; Buf: PChar; BufLen: Integer): Integer; stdcall;
var
  s : String;
begin
  Result := SpiAllRight;
  s := '';
  case InfoNo of
    0: s := PlugInfo0;
    1: s := PlugInfo1;
    2: s := PlugInfo2;
    3: s := PlugInfo3;
  end;

  if (s<>'') then
  begin
    ZeroMemory(buf,BufLen);
    strcopy(Buf,@s[1]);
    Result := Length(s);
  end;
end;

// WJ\(ΉĂ)t@C`ׂ
function IsSupported(FileName: PChar; DW: DWORD): Integer; stdcall;
var
  Data : PByte;
  Buf : array[0.._HedSize-1] of Byte;
  ReadBytes : DWORD;
begin
  Result := 0;
  if ((DW and $FFFF0000) = 0)then
  begin
    // DW̓t@Cnh
    if (ReadFile(DW, Buf, _HedSize, ReadBytes, nil) = False) then Exit;
    Data := @Buf;
  end
  else
  begin
    // DW̓obt@ւ̃|C^
    Data := Pointer(DW);
  end;

  // tH[}bgmF
  if (IsSupportedEx(FileName, Data)) then Result := 1;
end;

// 摜t@CɊւ𓾂
function GetPictureInfo(Buf: PChar; Len: Longint; Flag: Integer;var PictureInfo: TPictureInfo): Integer; stdcall;
var
  Data : PByte;
  HeadBuf : array[0.._HedSize-1] of Byte;
  ReadBytes : DWORD;
  hf : THandle;
  FileName: PChar;
begin
  if ((flag and 7) = 0) then
  begin // Buf̓t@C
    hf := CreateFile(Buf, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
    if (hf = INVALID_HANDLE_VALUE) then
    begin
      Result := SpiFileReadError;
      Exit;
    end;
    try
      //SetFilePointer(hf, len, nil, FILE_BEGIN);
      if (ReadFile(hf, HeadBuf, _HedSize, ReadBytes, nil) = False) then
      begin
        Result := SpiFileReadError;
        Exit;
      end;
    finally
      CloseHandle(hf);
    end;
    Data := @HeadBuf;
    FileName := Buf;
  end
  else
  begin // Buf̓t@CC[Wւ̃|C^
    Data := Pointer(Buf);
    FileName := nil;
  end;

  // tH[}bgmF
  if (IsSupportedEx(FileName, Data) = False) then
  begin
    Result := SpiUnknownFormat;
    Exit;
  end;

  Result := GetPictureInfoEx(PictureInfo, Data);
end;

// 摜WJ
function GetPicture(Buf: PChar; Len: Longint; Flag: Integer;var HBInfo: HLOCAL; var HBm: HLOCAL;ProgressCallback: TProgressCallback; lData: Longint): Integer; stdcall;
var
  DataBuf : PByte;
  hData : HLOCAL;
  DataSize : DWORD;
  ReadBytes : DWORD;
  hf : THandle;
  FileName: PChar;
begin
  Result := SpiAllRight;
  hData := THandle(nil);

  if ((flag and 7) = 0) then
  begin // Buf̓t@C
    hf := CreateFile(Buf, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
    if (hf = INVALID_HANDLE_VALUE) then
    begin
      Result := SpiFileReadError;
      Exit;
    end;
    try
      //MacoCiɑΉȂ
      DataSize := GetFileSize(hf, nil);
      if (DataSize = $FFFFFFFF) then
      begin
        Result := SpiFileReadError;
        Exit;
      end;
      hData := LocalAlloc(LMEM_MOVEABLE, DataSize);
      if (hData = HLOCAL(nil)) then
      begin
        Result := SpiNoMemory;
        Exit;
      end;
      try
        DataBuf := LocalLock(hData);
        if (DataBuf = nil) then
        begin
          Result := SpiMemoryError;
          Exit;
        end;
        if (ReadFile(hf, DataBuf^, DataSize, ReadBytes, nil) = False) then
        begin
          Result := SpiFileReadError;
          Exit;
        end;
      finally
        if (Result <> SpiAllRight) then
        begin
          //LocalUnlock(hData);
          LocalFree(hData);
        end;
      end;
    finally
      CloseHandle(hf);
    end;
    FileName := Buf;
  end
  else
  begin // Buf̓t@CC[Wւ̃|C^
    DataBuf := Pointer(Buf);
    DataSize := Len;
    FileName := nil;
  end;

  //Load
  Result := GetPictureEx(DataBuf, HBInfo, HBm, ProgressCallback, lData, DataSize);

  if (hData <> HLOCAL(nil)) then
  begin
    //LocalUnlock(hData);
    LocalFree(hData);
  end;
end;


// vr[EJ^O\p摜kWJ[eB
function GetPreview(Buf: PChar; Len: Longint; Flag: Integer;var HBInfo: HLOCAL; var HBm: HLOCAL;ProgressCallback: TProgressCallback; lData: Longint): Integer; stdcall;
begin
  Result:=SpiNotImplement;
end;

// Plug-inݒ_CAO\
function ConfigurationDlg(Parent: HWND; fnc: Integer): Integer; stdcall;
begin
  Result:=SpiNotImplement;
end;


end.


